//TOPSCCC 9188 demo program
//NAME:COM1234.C
//FUN :PC <--> 9188's COM1
//     PC <--> 9188's COM3 <--> 9188's COM2 <--> EX9017(A/I)
//     PC <--> 9188's COM4 
//DATE:2005.06.30
//#include<stdio.h>
//#include<conio.h>
//#include<string.h>
//#include<ctype.h>
//#include<time.h>
#include "..\lib\9188A8D.h"

int i,val,val1,val3,val4,t,j,num_data;
char str2[58],v[3],AAR[5];
int turn;
char c;
int quit = 0;
/************************************************/
void changetohex(){
	AAR[0]='#';

	val1=(i/16);
	itoa(val1,v,10);
	AAR[1] = v[0];

	val3=(i % 16);
	itoa(val3,v,16);
	AAR[2] = v[0];
	if (islower(v[0])) AAR[2] = toupper(v[0]);

	AAR[3] = 0x0d;
	AAR[4] = '\0';
}
/*************************************************/
void blinkled(){
  int ledmode=1;
  clock_t start,end,start2;
    end=clock();
    /*blink the led*/
    if((end-start)/CLK_TCK >= 0.1){
       ledmode=!ledmode;
       if (ledmode) LedOn(); else LedOff();
       start=clock();
    }
}
/*************************************************/
void send_com_from_comp2(){

    int read_com = 2;
    int no_response=0;
    //send data from COM2
    for (i=0;i<4;i++) 
    {
        ToCom(read_com,AAR[i]);
        WaitTransmitOver(read_com);
    }

    i=0;
    while(IsCom(read_com)==0) 	//wait for data
    {
      i++;
	  if (i>2000)
      {
		no_response=1;
		break;
	  }
    }
    //read data if there is any
    if(no_response==0)
    {
	  for (i=0;i<57;i++) str2[i]=ReadCom(read_com);
	  str2[57] = '\0';
	  printf("  Receive => %s \n",str2);
    }
    else  printf("  Error! There is no this Module.\n");
    ClearCom(read_com);    
}

void chkcomp(int temp1){
	for (i=0;i<2;i++)
	{
		v[i]=ReadCom(temp1);
		printf("%c",v[i]);
       	if ((v[i]=='q') || (v[i]=='Q'))
		{  
		   quit=1;
		   return;
		}
		DelayMs(500);
	}
	
	v[2] = '\0';
	i=atoi(v);
	if ((i<1) || (i>32))
	    printf("  Sorry over the CH range !\n");
	else{
	   changetohex();
	   printf("\n  COM =====> %d \n",temp1);
	   printf("  Send ====> %s \n",AAR);
	   //send_com = temp1;
	   send_com_from_comp2();
	}
	
	printf("\nTOPSCCC DEMO PROGRAM (@)");
 	printf("\nPls keyin the Address No. of 9017(01~32) : ");	
}

/* ------------------------------------------------------------------- */
void  main()
{

 InstallCom(1,57600L,8,0,1);	/* COM1, RS232 */
 InstallCom(2,9600L,8,0,1);	/* COM2, RS-485, half-duplex mode, INT	     */
				/*	 --> need to control 485 direction   */
				/*	 --> initial 485 direction = Receive */
 InstallCom(3,57600L,8,0,1);	/* COM3, RS232 */
 InstallCom(4,57600L,8,0,1);	/* COM4, RS232 */

 printf("\nTOPSCCC DEMO PROGRAM (@)");
 printf("\nPls keyin the Address No. of CH(01~32) : ");
 for (;!quit;) {

	blinkled();
        if (IsCom(1)==QueueIsNotEmpty) chkcomp(1);
        else if (IsCom(3)==QueueIsNotEmpty) chkcomp(3);
        else if (IsCom(4)==QueueIsNotEmpty) chkcomp(4);
 }
    RestoreCom(1);
    RestoreCom(2);
    RestoreCom(3);
    RestoreCom(4);
    LedOn();
    return;
}
