// TOPSCCC 9188 COMSTR
#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<time.h>
#include "..\lib\9188A8D.h"
unsigned CheckTime;
/* ------------------------------------------------------------------- */
void S5DL(int lr_flag,int dd1,int dd2,int dd3,int dd4,int dd5)
{
  unsigned int i,j;
  unsigned int ddx[7];
  ddx[1] = dd1;
  ddx[2] = dd2;
  ddx[3] = dd3;
  ddx[4] = dd4;
  ddx[5] = dd5;
  //Init5DigitLed();		/* 5-digit LED initial */
  for (i=1 ; i<6 ; i++)
  {
       for (j=1 ; j<i+1 ; j++)
       {
        if (lr_flag == 0)
	       Show5DigitLed(6-j,ddx[i-j+1]);  /* show - in 5-digit LED */
	    else
	       Show5DigitLed(j,ddx[j]);  /* show - in 5-digit LED */	    
        DelayMs(20);
       }
  }
  /*Show5DigitLed(1,dd1);		   show - in 5-digit LED */
  /*Show5DigitLed(2,dd2);		   show - in 5-digit LED */
  /*Show5DigitLed(3,dd3);		   show - in 5-digit LED */
  /*Show5DigitLed(4,dd4);		   show - in 5-digit LED */
  /*Show5DigitLed(5,dd5);		   show - in 5-digit LED */  
}
void  main()
{
 int i,val,t,j,num_data;
 char str[50];
 char v[50];
 int turn,send_com,read_com,no_response;
 char c;
 int ledmode=1;
 int quit=0;
 clock_t start,end,start2;
 Init5DigitLed();		/* initial & blank the 5-digit LED  */
 LedOn();			/* red-LED on			    */
 start=clock();
 
 InstallCom(4,57600L,8,0,1);	/* COM4, RS232 */
 InstallCom(3,57600L,8,0,1);	/* COM3, RS232 */
 printf("\nCOM4/COM3 RS232 test with multiple bytes of data\n");
 printf("Please input a string to send from COM4 to COM3:");
 for (;!quit;) {       
    end=clock();
    //blink the led
    if((end-start)/CLK_TCK >= 0.5){
       ledmode=!ledmode;
       if (ledmode) LedOn(); else LedOff();
       start=clock();
    }
    
    if (kbhit4()) {		/* is user press PC's keyboard from COM4   */
       i=0;    
       do{
        i++;
        str[i]=getch4();		/* if this key is Q or Q --> exit this program */
        printf("%c",str[i]);
        if ((str[i]=='q') || (str[i]=='Q')) goto recomstr;
       }while(str[i]!=0x0D); 

 //gets(str);
 
 no_response=0;

 send_com=4;
 read_com=3;
 //ToComStr(send_com,str);
 i=1;
 while(str[i]!=0x0D)
 {
   ToCom(send_com,str[i]);
   WaitTransmitOver(send_com);
   i++;
 }
 i=0;
 while(IsCom(read_com)==0) 	//wait for data
 {
   i++;
   if (i>30000)
   {
		no_response=1;
		break;
   }
 }

 //read data if there is any
 if(!no_response)
 {
	num_data=0;
	//read all the data in the COM port buffer
	while(IsCom(read_com)==1)
    {
		v[num_data]=ReadCom(read_com);
		num_data++;
	}
	printf("\ndata read from COM3: ");

	for(j=0;j<num_data;j++)
		printf("%c ",v[j]);

	printf("\n");
    printf("\nCOM4/COM3 RS232 test with multiple bytes of data\n");
    printf("Please input a string to send from COM4 to COM3:");
 }
 else
 {
	printf("\nCOM%i send %s --> COM%i no response",send_com,str,read_com);
	no_response=0;
 }
}//end of IF
}//end of FOR
recomstr:
 RestoreCom(4);
 RestoreCom(3);
 S5DL(0,9,1,8,8,14);
}
